<?xml version="1.0" encoding="UTF-8"?>

<!--
 Copyright 2007 ZXing authors

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
-->

<project name="core" default="build">

  <property file="../build.properties"/>

  <target name="init">
    <tstamp/>
  </target>

  <target name="build" depends="init">
    <mkdir dir="build"/>
    <javac srcdir="src"
           destdir="build"
           source="6"
           target="6"
           optimize="true"
           debug="true"
           deprecation="true"
           fork="true"
           includeantruntime="false">
    </javac>
    <jar jarfile="core.jar" basedir="build"/>
  </target>

  <target name="export" depends="build">
    <jar jarfile="core.jar" basedir="build"/>
    <copy file="core.jar" todir="../android/libs" overwrite="true"/>
    <copy file="core.jar" todir="../androidtest/libs" overwrite="true"/>
  </target>

  <target name="build-test" depends="init,build">
    <mkdir dir="build-test"/>
    <javac srcdir="test/src"
           destdir="build-test"
           debug="true"
           deprecation="true"
           includeantruntime="false">
      <classpath>
        <pathelement location="core.jar"/>
        <pathelement location="lib/junit-4.8.2.jar"/>
      </classpath>
    </javac>
  </target>

  <target name="test-blackbox" depends="build-test">
    <parallel failonany="true">
      <antcall target="test-blackbox-subset">
        <param name="subdir" value="aztec"/>
      </antcall>
      <antcall target="test-blackbox-subset">
        <param name="subdir" value="datamatrix"/>
      </antcall>
      <antcall target="test-blackbox-subset">
        <param name="subdir" value="negative"/>
      </antcall>
      <antcall target="test-blackbox-subset">
        <param name="subdir" value="oned"/>
      </antcall>
      <antcall target="test-blackbox-subset">
        <param name="subdir" value="pdf417"/>
      </antcall>
      <antcall target="test-blackbox-subset">
        <param name="subdir" value="qrcode"/>
      </antcall>
    </parallel>
  </target>

  <target name="test-blackbox-subset">
    <junit printsummary="on" haltonfailure="on" haltonerror="on" fork="true" dir=".">
      <formatter type="plain" usefile="false"/>
      <classpath>
        <pathelement location="core.jar"/>
        <pathelement location="build-test"/>
        <pathelement location="lib/junit-4.8.2.jar"/>
      </classpath>
      <assertions>
        <enable/>
      </assertions>
      <jvmarg value="-Djava.awt.headless=true"/>
      <batchtest>
        <fileset dir="test/src">
          <include name="**/${subdir}/*BlackBox*TestCase.java"/>
          <exclude name="**/Abstract*.java"/>
        </fileset>
      </batchtest>
    </junit>
  </target>

  <target name="test-unit" depends="build-test">
    <junit printsummary="on" haltonfailure="on" haltonerror="on" fork="true" dir=".">
      <formatter type="plain" usefile="false"/>
      <classpath>
        <pathelement location="core.jar"/>
        <pathelement location="build-test"/>
        <pathelement location="lib/junit-4.8.2.jar"/>
      </classpath>
      <assertions>
        <enable/>
      </assertions>
      <jvmarg value="-Djava.awt.headless=true"/>
      <batchtest>
        <fileset dir="test/src">
          <include name="**/*TestCase.java"/>
          <exclude name="**/*BlackBox*TestCase.java"/>
          <exclude name="**/Abstract*.java"/>
        </fileset>
      </batchtest>
    </junit>
  </target>

  <target name="test" depends="test-unit,test-blackbox"/>

  <target name="clean">
    <delete dir="build"/>
    <delete dir="build-test"/>
    <delete file="core.jar"/>
    <delete file="proguard-dump.txt"/>
  </target>

</project>
